package com.weaver.interfaces.kr.workflow.action;

import cn.hutool.http.HttpUtil;
import com.alibaba.fastjson.JSONObject;
import com.engine.kr.entity.kq.KqActionBO;
import com.engine.kr.entity.kq.KqGlobal;
import com.engine.kr.enums.KqInteractiveEnum;
import com.engine.kr.service.impl.KqInteractiveServiceImpl;
import weaver.interfaces.workflow.action.Action;
import weaver.soa.workflow.request.*;

import java.util.HashMap;
import java.util.Map;

/**
 * @author:dxfeng
 * @createTime: 2023/05/23
 * @version: 1.0
 */
public class KrBatchOvertimeCreateAction implements Action {
    @Override
    public String execute(RequestInfo requestInfo) {

        String billNo = "";
        String resourceId = "";

        MainTableInfo mainTableInfo = requestInfo.getMainTableInfo();
        Property[] properties = mainTableInfo.getProperty();
        for (Property property : properties) {
            String name = property.getName();
            String value = property.getValue();
            switch (name) {
                case "resourceId":
                    resourceId = KqActionBO.getUserName(value);
                    break;
                case "lcbh":
                    billNo = value;
                    break;
                default:
                    break;
            }
        }
        String token = new KqInteractiveServiceImpl().getToken();
        String addDay = requestInfo.getRequestManager().getCreatedate() + " " + requestInfo.getRequestManager().getCreatetime();
        String cfmBy = KqActionBO.getUserName(requestInfo.getLastoperator());
        String cfmDay = requestInfo.getRequestManager().getLastoperatedate() + " " + requestInfo.getRequestManager().getLastoperatetime();


        DetailTableInfo detailTableInfo = requestInfo.getDetailTableInfo();
        DetailTable detailTable = detailTableInfo.getDetailTable()[0];
        Row[] rows = detailTable.getRow();
        boolean isRun = true;
        for (Row row : rows) {
            if (!isRun) {
                break;
            }
            String personId = "";
            String otType = "";
            String otAdjuest = "";
            String beginDate = "";
            String beginTime = "";
            String endDate = "";
            String endTime = "";
            String billHours = "";
            String otReason = "";
            Cell[] cells = row.getCell();
            for (Cell cell : cells) {
                String name = cell.getName();
                String value = cell.getValue();
                switch (name) {
                    case "xm":
                        personId = KqActionBO.getWorkCode(value);
                        break;
                    case "jblx":
                        otType = KqActionBO.getWorkTypeCode(value);
                        break;
                    case "bcfs":
                        otAdjuest = value;
                        break;
                    case "ksrq":
                        beginDate = value;
                        break;
                    case "kssj":
                        beginTime = value;
                        break;
                    case "jsrq":
                        endDate = value;
                        break;
                    case "jssj":
                        endTime = value;
                        break;
                    case "jbsc":
                        billHours = value;
                        break;
                    case "jbsy":
                        otReason = value;
                        break;
                    default:
                        break;
                }
            }
            // 每一行发起一次请求
            Map<String, Object> params = new HashMap<>();
            params.put("token", token);
            params.put("personId", personId);
            params.put("billNo", billNo + "-" + row.getId());
            params.put("otType", otType);
            params.put("otAdjuest", otAdjuest);
            params.put("beginDate", beginDate);
            params.put("beginTime", beginTime);
            params.put("endDate", endDate);
            params.put("endTime", endTime);
            params.put("billHours", billHours);
            params.put("runsNo", null);
            params.put("otReason", otReason);
            params.put("addBy", resourceId);
            params.put("addDay", addDay);
            params.put("cfmBy", cfmBy);
            params.put("cfmDay", cfmDay);
            // 1新增、2变动、3取消
            params.put("billStat", 1);

            String returnStr = HttpUtil.post(KqGlobal.POST_URL + KqInteractiveEnum.OVERTIME_CREATE.getPostPath(), params);
            JSONObject jsonObject = JSONObject.parseObject(returnStr);
            String code = jsonObject.getString("code");
            if (!KqGlobal.SUC_CODE.equals(code)) {
                requestInfo.getRequestManager().setMessagecontent(jsonObject.getString("msg"));
                isRun = false;
            }
        }

        if (isRun) {
            return SUCCESS;
        }
        return FAILURE_AND_CONTINUE;
    }
}
